/**********************************************************************
 *<
	FILE: maxProject.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2003, All Rights Reserved.
 **********************************************************************/

#include "maxProject.h"
#include "tinyxml/tinyxml.h"

#ifdef _DEBUG
#pragma comment(lib, "tinyxmld")
#else
#pragma comment(lib, "tinyxml")
#endif

#define maxProject_CLASS_ID	Class_ID(0xbc9deb14, 0x9c675a96)

class maxProject : public SceneExport {
	public:
		
		static HWND hParams;
		
		int				ExtCount();					// Number of extensions supported
		const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
		const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
		const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
		const TCHAR *	AuthorName();				// ASCII Author name
		const TCHAR *	CopyrightMessage();			// ASCII Copyright message
		const TCHAR *	OtherMessage1();			// Other message #1
		const TCHAR *	OtherMessage2();			// Other message #2
		unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
		void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box

		BOOL SupportsOptions(int ext, DWORD options);
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts=FALSE, DWORD options=0);

		//Constructor/Destructor
		maxProject();
		~maxProject();		

private:
		TSTR   GetDepthString(int nDepth_);
		TCHAR* FixupName(TCHAR* name);
		void   ExportGeometryObject(FILE* pFile, Interface* pInterface);
		void   TraverseNode(FILE* pFile, INode* pNode, int nDepth);
		TriObject* GetTriObjectFromNode(INode *node, TimeValue t, int &deleteIt);
		TSTR	Format(Point3 value);
		void	CommaScan(TCHAR* buf);

private:
		TCHAR		m_szFmtStr[16];
};



class maxProjectClassDesc : public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new maxProject(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_NAME); }
	SClass_ID		SuperClassID() { return SCENE_EXPORT_CLASS_ID; }
	Class_ID		ClassID() { return maxProject_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("maxProject"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }					// returns owning module handle
	

};

static maxProjectClassDesc maxProjectDesc;
ClassDesc2* GetmaxProjectDesc() { return &maxProjectDesc; }





INT_PTR CALLBACK maxProjectOptionsDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) {
	static maxProject *imp = NULL;

	switch(message) {
		case WM_INITDIALOG:
			imp = (maxProject *)lParam;
			CenterWindow(hWnd,GetParent(hWnd));
			return TRUE;

		case WM_CLOSE:
			EndDialog(hWnd, 0);
			return 1;
	}
	return 0;
}


//--- maxProject -------------------------------------------------------
maxProject::maxProject()
{

}

maxProject::~maxProject() 
{

}

int maxProject::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}

const TCHAR *maxProject::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("myf");
}

const TCHAR *maxProject::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("");
}
	
const TCHAR *maxProject::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("My Format");
}

const TCHAR *maxProject::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("");
}

const TCHAR *maxProject::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("");
}

const TCHAR *maxProject::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}

const TCHAR *maxProject::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}

unsigned int maxProject::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}

void maxProject::ShowAbout(HWND hWnd)
{			
	// Optional
}

BOOL maxProject::SupportsOptions(int ext, DWORD options)
{
	// TODO Decide which options to support.  Simply return
	// true for each option supported by each Extension 
	// the exporter supports.

	return TRUE;
}

extern void WriteXml();

int	maxProject::DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts, DWORD options)
{
	//TODO: Implement the actual file Export here and 
	//		return TRUE If the file is exported properly
	WriteXml();

	if(!suppressPrompts)
		DialogBoxParam(hInstance, 
				MAKEINTRESOURCE(IDD_PANEL), 
				GetActiveWindow(), 
				maxProjectOptionsDlgProc, (LPARAM)this);

	//ͽƮ е 
	int nPrecision = 4;
	sprintf(m_szFmtStr, "%%4.%df", nPrecision);

	//  
	FILE* fp = fopen(name, "w");
	
	ExportGeometryObject( fp, i );
	
	//  ݱ
	fclose(fp);
	return TRUE;
}


TSTR maxProject::GetDepthString(int nDepth_)
{

	TSTR tsrtDepth = "";
	for(int i = 0; i < nDepth_; ++i)
		tsrtDepth +="\t";

	return tsrtDepth;

}

// Replace some characters we don't care for.
TCHAR* maxProject::FixupName(TCHAR* name)
{
	static char buffer[256];
	TCHAR* cPtr;
	
    _tcscpy(buffer, name);
    cPtr = buffer;
	
    while(*cPtr) {
		if (*cPtr == '"')
			*cPtr = 39;
        else if (*cPtr <= 31)
			*cPtr = _T('_');
        cPtr++;
    }
	
	return buffer;
}

void maxProject::ExportGeometryObject(FILE* pFile, Interface* pInterface)
{
	//  ó
	//if(0 == (EXPORTOPT_MESH & m_dwExportOption))
	//	return ;

	// ̽ Ʈ 带 ȹ
	INode* pRoot = pInterface->GetRootNode();
	
	// Ʈ  ڽ  ȹ
	int nChlildren = pRoot->NumberOfChildren();

	// ڽĳ ŭ
	for(int i = 0; i < nChlildren; ++i)
	{
		//  ڽ  ȹ
		INode* pChild = pRoot->GetChildNode(i);

		//  带 ȸѴ.
		TraverseNode(pFile, pChild, 0);
	}
}


void maxProject::TraverseNode(FILE* pFile, INode* pNode, int nDepth)
{
	float t = 0.0f;  //ð 

	//  ڿ 
	TSTR tstrDepth = GetDepthString(nDepth);
	Matrix3 tm = pNode->GetObjTMAfterWSM(t);  //Nodeκ Word Matrix о´.


	//  尡 ׷  ˻.
	if(TRUE == pNode->IsGroupHead())
	{
		fprintf(pFile, "%s*GROUP \"%s\" {\n", tstrDepth.data(), FixupName(pNode->GetName()));
		++nDepth;
	}

	const ObjectState objState = pNode->EvalWorldState(t);
	if (!objState.obj || objState.obj->SuperClassID() != GEOMOBJECT_CLASS_ID) 
	{
		return; // Safety net. This shouldn't happen.
	}

	//  Ʈ ȹѴ.
	Object* pObj = objState.obj;

	if(NULL != pObj)
	{
		// Ʈ  Ŭ ̵ Ȯϰ  Ʈ óѴ.
		switch(pObj->SuperClassID())
		{
		//  Ʈ̸
		case GEOMOBJECT_CLASS_ID:
			{
				//  Ʈ 
				fprintf(pFile, "%s\t%s\n", tstrDepth.data(), FixupName(pNode->GetName()));
				BOOL needDel;
				TriObject* tri = GetTriObjectFromNode(pNode, t, needDel);
				if (!tri) 
					return;
				
				Mesh* mesh = &tri->GetMesh();
				fprintf(pFile, "%s%s {\n", tstrDepth.data(),  _T("*MESH"));
				fprintf(pFile, "%s\t%s %d\n", tstrDepth.data(), _T("*TIMEVALUE"), t);
				fprintf(pFile, "%s\t%s %d\n",tstrDepth.data(), _T("*MESH_NUMVERTEX"), mesh->getNumVerts());
				fprintf(pFile, "%s\t%s %d\n",tstrDepth.data(), _T("*MESH_NUMFACES"), mesh->getNumFaces());

				// Export the vertices
				fprintf(pFile,"%s\t%s {\n",tstrDepth.data(), _T("*MESH_VERTEX_LIST"));
				for (int i=0; i < mesh->getNumVerts(); i++) 
				{
					//Point3 v = tm * Inverse(node->GetNodeTM(t)) * mesh->verts[i]; 
					Point3 v = tm * mesh->verts[i];
					fprintf(pFile, "%s\t\t%s %4d\t%s\n",tstrDepth.data(), _T("*MESH_VERTEX"), i, Format(v));
				}
				fprintf(pFile,"%s\t}\n",tstrDepth.data()); // End vertex list
			}
			break;

		case CAMERA_CLASS_ID:  //ī޶
		case LIGHT_CLASS_ID:   //
		case SHAPE_CLASS_ID:   //
		case HELPER_CLASS_ID:  //
		default :
			break;
		}
	}

	//ڽ ó
	int nChlildren = pNode->NumberOfChildren();
	for(int i = 0; i < nChlildren; ++i)
	{
		INode* pChild = pNode->GetChildNode(i);
		TraverseNode(pFile, pChild, nDepth);
	}

	// ׷ 
	if(TRUE == pNode->IsGroupHead())
	{
		fprintf(pFile, "%s}\n", tstrDepth.data());
		--nDepth;
	}
}

// Return a pointer to a TriObject given an INode or return NULL
// if the node cannot be converted to a TriObject
TriObject* maxProject::GetTriObjectFromNode(INode *node, TimeValue t, int &deleteIt)
{
	deleteIt = FALSE;
	Object *obj = node->EvalWorldState(t).obj;
	if (obj->CanConvertToType(Class_ID(TRIOBJ_CLASS_ID, 0))) 
	{ 
		TriObject *tri = (TriObject *) obj->ConvertToType(t, Class_ID(TRIOBJ_CLASS_ID, 0));
		// Note that the TriObject should only be deleted
		// if the pointer to it is not equal to the object
		// pointer that called ConvertToType()
		if (obj != tri) deleteIt = TRUE;
		return tri;
	}
	else 
	{
		return NULL;
	}
}

TSTR maxProject::Format(Point3 value)
{
	TCHAR buf[120];
	TCHAR fmt[120];
	
	sprintf(fmt, "%s\t%s\t%s", m_szFmtStr, m_szFmtStr, m_szFmtStr);
	sprintf(buf, fmt, value.x, value.y, value.z);

	CommaScan(buf);
	return buf;
}

// International settings in Windows could cause a number to be written
// with a "," instead of a ".".
// To compensate for this we need to convert all , to . in order to make the
// format consistent.
void maxProject::CommaScan(TCHAR* buf)
{
    for(; *buf; buf++) if (*buf == ',') *buf = '.';
}

void WriteXml()
{
	// 
	TiXmlDocument doc;  
	TiXmlDeclaration* decl = new TiXmlDeclaration( "1.0", "euc-kr", "" );  
	doc.LinkEndChild( decl ); 

	//  ߰
	TiXmlElement * root = new TiXmlElement( "root" );  
	doc.LinkEndChild( root );  

	//ּ ߰
	TiXmlComment * comment = new TiXmlComment();
	comment->SetValue( " ǥ ĵ̴." );  
	root->LinkEndChild( comment );  

	//root ڽ food   ߰
	TiXmlElement *food = new TiXmlElement( "food" );  
	root->LinkEndChild( food );  

	//food Attribute "num" ߰
	food->SetAttribute("num", 1);   //food->SetAttribute("num", "1") 

	//food ڽ name    ߰
	TiXmlElement *name = new TiXmlElement( "name" );  
	food->LinkEndChild( name );  
	name->LinkEndChild( new TiXmlText( "ġ" )); 

	//food ڽ country    ߰
	TiXmlElement *country = new TiXmlElement( "country" );  
	food->LinkEndChild( country );  
	country->LinkEndChild( new TiXmlText( "ѹα" )); 

	doc.SaveFile("test_write.xml");
}